/*Lesson 10.2 Demo 1 - Use the INSERT SELECT and SELECT INTO Statements */

USE AdventureWorks2012
GO

-->>>>>>>>>>>>>>>>>>>>>>>>>>>INSERT SELECT>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
---First create the target table--------------------------------------------------------------
IF OBJECT_ID('HumanResources.Programmers') IS NOT NULL DROP TABLE HumanResources.Programmers;
GO

CREATE TABLE HumanResources.Programmers
(
  entityID INT NOT NULL IDENTITY(1, 1)
    CONSTRAINT PK_Programmers_entityID PRIMARY KEY,
  loginID  nvarchar(256) NOT NULL,
  JobTitle nvarchar(50) NOT NULL,
  HireDate DATE NOT NULL
    CONSTRAINT DFT_Programmers_HireDate DEFAULT (CAST(SYSDATETIME() AS DATE)),
  VacationHours smallint NOT NULL
);

---------------------------------------------------------------------
----USE INSERT SELECT -----------------------------------------------
---------------------------------------------------------------------

SET IDENTITY_INSERT HumanResources.Programmers  ON;

INSERT INTO HumanResources.Programmers (entityID, loginID, JobTitle, HireDate, VacationHours)
  SELECT BusinessEntityID, loginID, JobTitle, HireDate, VacationHours
  FROM HumanResources.Employee
  WHERE SalariedFlag = 0;

SET IDENTITY_INSERT HumanResources.Programmers OFF;

-- query the table---------------------------------------------------
SELECT entityID, loginID, JobTitle, HireDate, VacationHours
FROM HumanResources.Programmers;

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
---- USE SELECT INTO ----------------------------------------------------------------------
-------------------------------------------------------------------------------------------

---Start with only the original table -------------------------------
IF OBJECT_ID('HumanResources.Programmers', 'U') IS NOT NULL 
DROP TABLE HumanResources.Programmers;

--Use SELECT INTO TO CREATE AND FILL the Programmers table ---------
--with only programmers employed by company -------------------------
SELECT BusinessEntityID, loginID, JobTitle, HireDate, VacationHours
INTO HumanResources.Programmers
FROM HumanResources.Employee
WHERE SalariedFlag = 0;
GO
-- query the table
SELECT BusinessEntityID, loginID, JobTitle, HireDate, VacationHours
FROM HumanResources.Programmers;

-->>>>>>HumanResources.Programmers used in Demo 2>>>>>>>>>>>>>>>>>>
-- cleanup by deleting Programmers table ---------------
--IF OBJECT_ID('HumanResources.Programmers', 'U') IS NOT NULL 
--DROP TABLE HumanResources.Programmers;
--GO
