/* Lesson 11.3 Demo 1  Use UNION and UNION ALL to Combine Datasets */
--Create two temporary tables-----------------------------------------------------------
--Fill the tables with data such that they create two disjoint sets - no  common rows---
--Combine tables first using UNION and, in second query, use UNION ALL------------------
--Use the Actual Execution Plane to note the performance cost of the two queries--------

USE AdventureWorks2012
GO

-- DROP #tempTable1 and #TempTable2 if they already exist --
IF OBJECT_ID(N'tempdb..#tempTable1', N'U') IS NOT NULL 
DROP TABLE #tempTable1;
GO
IF OBJECT_ID(N'tempdb..#tempTable2', N'U') IS NOT NULL 
DROP TABLE #tempTable2;
GO

--SELECT * FROM Person.Person
--GO

-- Create First table: #tempTable1
SELECT FirstName, LastName into #tempTable1
FROM Person.Person
where BusinessEntityID <= 100
GO

-- Create a second table: #tempTable2
SELECT FirstName, LastName into #tempTable2
FROM Person.Person
where BusinessEntityID > 100 and BusinessEntityID <= 200
GO

----INCLUDE THE ACTUAL EXECUTION PLAN  CTRL-M ------
----EXECUTE BOTH QUERIES----
SET STATISTICS PROFILE ON
 
SELECT * FROM #tempTable1
UNION
SELECT * FROM #tempTable2
GO

SELECT * FROM #tempTable1
UNION ALL
SELECT * FROM #tempTable2
GO
 
----TURN OFF THE ACTUAL EXECUTION PLAN  CTRL-M ------ 
SET STATISTICS PROFILE OFF
 
-- Final Cleanup
drop table #tempTable1
drop table #tempTable2
