/* Lesson 12 Create and Alter Stored Procedures - INLINE */


-->>>>>>>>>>>>>>>>LESSON 12.1>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
USE CertData
GO

IF OBJECT_ID ( 'Sales.uspGetUKCustomers', 'P' ) IS NOT NULL 
    DROP PROCEDURE Sales.uspGetUKCustomers;
GO
CREATE PROCEDURE Sales.uspGetUKCustomers
AS
    SELECT Company, ContactName
    FROM Sales.Customers
	WHERE CountryRegion = N'UK';
GO

-->>>>>>Invoke the Procedure<<<<<<<-----------------
EXECUTE Sales.uspGetUKCustomers;
GO

-->>>>>>Return procedure definition<<<<<<------------ 
Select *
FROM sys.sql_modules 


-->>>>>>>>>>>>>>LESSON12.2>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
USE CertData
GO

-->>>>>>Using INPUT PARAMETERS<<<<<<--------------------------
IF OBJECT_ID ( 'Sales.uspGetCustomers', 'P' ) IS NOT NULL 
    DROP PROCEDURE Sales.uspGetCustomers;
GO
CREATE PROC Sales.uspGetCustomers
	@CountryRegion AS varchar(20)
AS
BEGIN
	SET NOCOUNT ON
    SELECT Company, ContactName
    FROM Sales.Customers
	WHERE CountryRegion = @CountryRegion;
END;
GO

-->>>>>>Invoke the Procedure<<<<<<---------------------
EXEC Sales.uspGetCustomers @CountryRegion = 'UK';

-->>>>>>Using OUTPUT PARAMETER<<<<<<---------------------------
USE CertData
GO

IF OBJECT_ID ( 'Sales.uspGetCustomers', 'P' ) IS NOT NULL 
    DROP PROCEDURE Sales.uspGetCustomers;
GO

USE CertData
GO

CREATE PROC Sales.uspGetCustomers
	@CountryRegion AS varchar(20),
	@numcustomers AS INT = 0 OUTPUT
AS
BEGIN
	SET NOCOUNT ON
    SELECT Company, ContactName
    FROM Sales.Customers
	WHERE CountryRegion = @CountryRegion;
	SET @numcustomers = @@ROWCOUNT;
	RETURN;
END;
GO

-->>>>>>Invoke the Procedure<<<<<<---------------------
DECLARE @numberofcust AS INT
EXEC Sales.uspGetCustomers @CountryRegion = 'UK', @numcustomers = @numberofcust OUTPUT;
SELECT @numberofcust AS "Number of Customers in Region"

-->>>>>>>>>>>>>>>>LESSON 12.4>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
USE CertData;
GO

-->>>>>>IF...ELSE<<<<<<-------------------------------------
IF 
(SELECT COUNT(*) FROM Production.Products WHERE ProductName LIKE '%Designing%' ) = 0
  PRINT 'There are no products on Designing'
ELSE
  PRINT 'There are products on Designing';
GO

-->>>>>>WHILE<<<<<<----------------------------------------- 
USE CertData
GO

SET NOCOUNT ON;
DECLARE @ID AS INT = 1;
WHILE @ID <= 5
	BEGIN
		PRINT @ID;
		SET @ID += 1; --@ID incremented by 1 within loop
	END;
GO

-->>>>>>WAITFOR<<<<<<-----------------------------------------

--Pause code execution for 30 seconds-- 
WAITFOR DELAY '00:00:30';
GO

-->>>>>>>>>>Lesson 12.6>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
USE CertData
GO
-->>>>ALTER PROCEDURE<<<<-------------------------------------------
ALTER PROC Sales.uspGetCustomers
	@CountryRegion AS varchar(20),
	@numcustomers AS INT = 0 OUTPUT
AS
BEGIN
	SET NOCOUNT ON
    SELECT CustomerID, Company, ContactName
    FROM Sales.Customers
	WHERE CountryRegion = @CountryRegion;
	SET @numcustomers = @@ROWCOUNT;
	RETURN;
END;
GO

-->>>>Check Procedure deppendencies before DROP<<<<--------------------

USE AdventureWorks2012
GO

SELECT *
 FROM sys.sql_expression_dependencies
 WHERE referencing_id = OBJECT_ID(N'HumanResources.uspUpdateEmployeePersonalInfo');
GO


