/* Lesson 13.4 Demo 1 - Create and Alter User-Defined Functions */
/* Also implementing the UDF                                    */
USE AdventureWorks2012;
GO

IF OBJECT_ID (N'dbo.ufnGetPersonFullName', N'FN') IS NOT NULL
    DROP FUNCTION dbo.ufnGetPersonFullName;
GO

-->>>>CREATE User-Defined Function<<<<-----------------------------
CREATE FUNCTION dbo.ufnGetPersonFullName
(
	@FirstName nvarchar(50)
	,@LastName nvarchar(50)
)
RETURNS nvarchar(101)
As
BEGIN
	DECLARE @ret nvarchar(101);
	SELECT @ret = (FirstName + ' '+ LastName)
	FROM Person.Person
	WHERE Firstname = @FirstName
		AND LastName = @LastName;
	RETURN @ret;	
END;
GO 

-->>>>Implement the User-Defined Function<<<<-------------------------
SELECT dbo.ufnGetPersonFullName (FirstName,LastName) as Name
	FROM Person.Person
	WHERE BusinessEntityID <= 20 
ORDER BY BusinessEntityID;
GO

-->>>>ALTER Function to add the middle name if it exists<<<<---------------
ALTER FUNCTION dbo.ufnGetPersonFullName
(
	@FirstName nvarchar(50)
	,@MiddleName nvarchar(50)
	,@LastName nvarchar(50)
)
RETURNS nvarchar(152)
As
BEGIN
	DECLARE @ret nvarchar(152);
		SELECT @ret = (FirstName + ' '+ ISNULL(MiddleName, '') + ' ' + LastName)
	FROM Person.Person
	WHERE Firstname = @FirstName
		AND LastName = @LastName;
	RETURN @ret;	
END;
GO 

-->>>>Implementing the ALTERED UDF<<<<----------------------------------------
SELECT dbo.ufnGetPersonFullName (FirstName,MiddleName, LastName) as Name
	FROM Person.Person
	WHERE BusinessEntityID <= 20 
ORDER BY BusinessEntityID;
GO