/* Lesson 15 Manage Transactions INLINE Code */

-->>>>>>Lesson 15.1 Apply Transaction Commands<<<<<<---------

USE AdventureWorks2012;
GO

DECLARE @IMPLICIT_TRANSACTIONS VARCHAR(3) = 'OFF';
  IF ( (2 & @@OPTIONS) = 2 ) SET @IMPLICIT_TRANSACTIONS = 'ON';
SELECT @IMPLICIT_TRANSACTIONS AS IMPLICIT_TRANSACTIONS;
GO

-->>>>>>>Lesson 15.2 Use WITH MARK Statement<<<<<<<------------------
--Transaction named and Marked---------------------------------------

USE AdventureWorks2012;
GO

BEGIN TRANSACTION DeleteJobCandidate
    WITH MARK N'Deleting Job Candidate';
	DELETE FROM AdventureWorks2012.HumanResources.JobCandidate
    WHERE JobCandidateID = 13;
COMMIT TRANSACTION DeleteJobCandidate;
GO

----View Transaction Log-----------------------------------------
-->>>>>>DBCC LOG(<databasename >, <type of output>)<<<<<<--------
--DBCC LOG(AdventureWorks2012,2);
--GO 


-->>>>>>Restoring Database to the Transaction Mark<<<<<<-----------

RESTORE DATABASE AdventureWorks2012 
	FROM DISK = 'C:SQLBackups\AdventureWorks2012.bak'
	WITH NORECOVERY;
GO
RESTORE LOG AdventureWorks2012 
	FROM DISK = 'C:\SQLBackups\AdventureWorks2012.trn'
	WITH STOPATMARK = 'DeleteJobCandidate';
GO
