USE AdventureWorks2012;
GO

BEGIN TRY
    BEGIN TRANSACTION;
		-->> SET XACT_ABORT ON renders transaction uncommittable
		-->> when constraint violation occurs
		SET XACT_ABORT ON;
        -->> FOREIGN KEY constraint exists on this table
        -->> Satement will generate constraint violation error
        DELETE FROM Production.Product
            WHERE ProductID = 328;

    -->> If delete operation succeeds, commit transaction 
	-->> and CATCH block will not execute
    COMMIT TRANSACTION;
END TRY
BEGIN CATCH
        -->> Test if transaction uncommittable
    IF (XACT_STATE()) = -1
    BEGIN
        PRINT 'Transaction cannot be committed' +
              ' Rolling back transaction'
        ROLLBACK TRANSACTION;
    END;

    -->> Test if transaction is active
    IF (XACT_STATE()) = 1
    BEGIN
        PRINT 'Transaction is committable' + 
              ' Committing transaction'
        COMMIT TRANSACTION;   
    END;
END CATCH;
GO
SET XACT_ABORT OFF;
GO