/* Lesson 4.9 Demo   Understand Inserted and Deleted Tables When Using an AFTER Trigger */

USE CertData
GO

/* Delete Trigger if already created in table */
IF OBJECT_ID (N'Production.tr_ProductionCategories_Test', N'TR') IS NOT NULL
   DROP TRIGGER Production.tr_ProductionCategories_Test;
GO

/* CREATE the AFTER Trigger to display the inserted and deleted tables
   created by the trigger
 */
CREATE TRIGGER Production.tr_ProductionCategories_Test
ON Production.Categories
AFTER INSERT, UPDATE, DELETE
AS
BEGIN
  SELECT * FROM inserted
  SELECT * FROM deleted
END;
GO

/* INSERT a new row INTO the Categories table.
   The inserted and deleted tables from the trigger are displayed
*/
INSERT INTO Production.Categories (CategoryName ,description)
	VALUES(N'MCSA Windows Server 2012', N'Microsoft Solutions Associate');
GO

/* DELETE a row FROM the Categories table.
   The inserted and deleted tables from the trigger are displayed
*/
DELETE FROM Production.Categories
	WHERE CategoryName = 'MCSA Windows Server 2012';
GO 

/* INSERT a new row INTO the Categories table.
   The inserted and deleted tables from the trigger are displayed
*/
INSERT INTO Production.Categories (categoryname ,description)
	VALUES(N'MCSA Windows Server 2008', N'Microsoft Solutions Associate');
GO

/* Display the data in the Categories table */
SELECT CategoryID
FROM Production.Categories
WHERE CategoryName = 'MCSA Windows Server 2008';
GO

/* UPDATE a row in the Categories table.
   The inserted and deleted tables from the trigger are displayed
*/
UPDATE Production.Categories
SET CategoryName = 'MCSA Windows Server 2012'
WHERE CategoryID = 8

/* Display the data in the Categories table */
SELECT *
FROM Production.Categories;
GO

/* Delete the MCSA Windows Server 2012 row */
DELETE FROM Production.Categories
	WHERE CategoryName = 'MCSA Windows Server 2012';
GO 

/* Delete the trigger */
IF OBJECT_ID (N'Production.tr_ProductionCategories_Test', N'TR') IS NOT NULL
   DROP TRIGGER Production.tr_ProductionCategories_Test;
GO

/* Display the data in the Categories table */
SELECT *
FROM Production.Categories;
GO