/* Lesson 5.6 Demo 2 - Use ORDER BY, DISTINCT, and Aliases */
USE AdventureWorks2012
GO

/* Using ORDER BY, DISTINCT, and Aliases */

-- Using single column specified in SELECT --
SELECT ProductID, Name, Color
FROM Production.Product
WHERE Color = 'Red'
ORDER BY Name;
GO

--Using an alias as the sort column --
SELECT ProductID, Name AS 'Product Name', Color
FROM Production.Product
WHERE Color = 'White'
ORDER BY 'Product Name';
GO

--Sorting by a column not in the SELECT statement --
SELECT ProductID, Name, Color
FROM Production.Product
WHERE Color = 'Red'
ORDER BY ListPrice;
GO 

--Specifying a descending sort order --
SELECT ProductID, Name, Color
FROM Production.Product
WHERE Color = 'Red'
ORDER BY ProductID DESC;
GO

--Specifying DISTINCT --
SELECT DISTINCT Color
FROM Production.Product
ORDER BY Color;
GO

--Specifying DISTINCT ORDER BY column not in SELECT --
--Query not valid --
SELECT DISTINCT Color
FROM Production.Product
ORDER BY ProductID;
GO

--ORDER BY column not in SELECT --
--Removed DISTINCT - this query valid --
SELECT Color
FROM Production.Product
ORDER BY ProductID;
GO

