/* Lesson 7.5 Demo 1 - part 2 Use Data Types for  Dates */
----------------------------------------------------
--Querying Date and Time ---------------------------
--Know if source data includes time and if time
--other than midnight has been entered
--Otherwise queries will not resolve correctly
----------------------------------------------------

USE AdventureWorks2012
GO

--Query orderdate from Sales.SalesOrderHeader------
SELECT SalesOrderID, OrderDate
FROM Sales.SalesOrderHeader;
GO

SELECT SalesOrderID, OrderDate
FROM Sales.SalesOrderHeader
WHERE OrderDate = '20050704';
GO

--------------------------------------------------------
---Create table Sales.SalesOrderDateTest and fill with data
-----------------------------------------------------------

IF OBJECT_ID('Sales.SalesOrderDateTest', 'U') IS NOT NULL 
DROP TABLE Sales.SalesOrderDateTest;
GO

SELECT SalesOrderID, OrderDate
INTO Sales.SalesOrderDateTest
FROM Sales.SalesOrderHeader
WHERE SalesOrderID >= 43700 and SalesOrderID < 43713
GO

SELECT * 
FROM Sales.SalesOrderDateTest;
GO

-----------------------------------------------------------
--Add data with dates that have a time value also---------
-----------------------------------------------------------

SET IDENTITY_INSERT Sales.SalesOrderDateTest  ON;

INSERT INTO Sales.SalesOrderDateTest(SalesOrderID, OrderDate)
VALUES (50001, '2005-07-04 00:35'),
(50002, '2005-07-04 11:30'),
(50003, '2005-07-04 12:45');
GO

SET IDENTITY_INSERT Sales.SalesOrderDateTest  OFF;


--Query the table-------------------------------------
--for all inserted orders-----------------------------
-------------------------------------------------------
SELECT SalesOrderID, OrderDate
FROM Sales.SalesOrderDateTest;
GO

----Query for a date which also has timed data-----------
----Not all values are returned--------------------------
SELECT SalesOrderID, OrderDate
FROM Sales.SalesOrderDateTest
WHERE OrderDate = '20050704';
GO

---Need to change the query to account for time past midnight
-------------------------------------------------------------
SELECT SalesOrderID, OrderDate
FROM Sales.SalesOrderDateTest
WHERE OrderDate >= '20050704' AND OrderDate < '20050705';
GO

-----------------------------------------------------------
---------Using DATEADD function to add 2 days to OrderDate
-----------------------------------------------------------

SELECT SalesOrderID
    ,OrderDate 
    ,DATEADD(day,2,OrderDate) AS PromisedShipDate
FROM Sales.SalesOrderDateTest;
GO

------------------------------------------------------------------
---------Using EOMONTH function to OrderDate to create billing date
-------------------------------------------------------------------

SELECT SalesOrderID
    ,OrderDate 
    ,EOMONTH(OrderDate) AS BillingDate
FROM Sales.SalesOrderDateTest;
GO

---------------------------------------------------------------
---------Using DATEFROMPARTS function (new in SQL Server 2012)--
---------to create date from its parts-------------------------
---------------------------------------------------------------
SELECT DATEFROMPARTS ( 2014, 04, 01 ) AS Result;

SELECT SalesOrderID
    ,OrderDate 
    ,DATEADD(day,2,OrderDate) AS PromisedShipDate
FROM Sales.SalesOrderDateTest;

/*-----------------------------------------------------------
---------Cleanup -DROP Table Sales.SalesOrderDateTest--------
UNLESS GOING ON TO Lesson 7.8 DEMO 2 - KEEP Sales.SalesOrderDateTest
-------------------------------------------------------------  
*/
IF OBJECT_ID('Sales.SalesOrderDateTest', 'U') IS NOT NULL 
DROP TABLE Sales.SalesOrderDateTest;
GO

