/* Lesson 8 INLINE Code */

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
---Lesson 8.3 Define Multiple Grouping Sets - INLINE--------------------------------- 

----Simple GROUP BY with ORDER BY----------------------------------------------------
USE AdventureWorks2012
GO

SELECT ShipMethodID, YEAR(OrderDate) AS N'Year Ordered', COUNT(*) AS 'Number of Orders'
	FROM Sales.SalesOrderHeader
	GROUP BY ShipMethodID, YEAR(OrderDate)
	ORDER BY ShipMethodID, YEAR(OrderDate);
GO

--------------Using GROUPING SETS Clause----------------------------------------------
USE AdventureWorks2012
GO

SELECT ShipMethodID, YEAR(OrderDate) AS N'Year Ordered', COUNT(*) AS 'Number of Orders'
	FROM Sales.SalesOrderHeader
	GROUP BY GROUPING SETS
	(
	ShipMethodID, YEAR(OrderDate)
	)
	ORDER BY ShipMethodID, YEAR(OrderDate);
GO
	
----------Using 4 GROUPING SETS-------------------------------------------------------
USE AdventureWorks2012
GO

SELECT ShipMethodID, YEAR(OrderDate) AS N'Year Ordered', COUNT(*) AS 'Number of Orders'
	FROM Sales.SalesOrderHeader
	GROUP BY GROUPING SETS
	(
	(ShipMethodID, YEAR(OrderDate))
	,(ShipMethodID                )
	,(YEAR(OrderDate)             )
	,(                            )
	)
	ORDER BY ShipMethodID, YEAR(OrderDate);
GO

---------------Using ROLLUP-----------------------------------------------------------
USE AdventureWorks2012
GO

SELECT ShipMethodID, YEAR(OrderDate) AS N'Year Ordered', COUNT(*) AS 'Number of Orders'
	FROM Sales.SalesOrderHeader
	GROUP BY ROLLUP
	(
	ShipMethodID, YEAR(OrderDate)
	)
	ORDER BY ShipMethodID, YEAR(OrderDate);
GO

---------------Using CUBE-----------------------------------------------------------
USE AdventureWorks2012
GO

SELECT ShipMethodID, YEAR(OrderDate) AS N'Year Ordered', COUNT(*) AS 'Number of Orders'
	FROM Sales.SalesOrderHeader
	GROUP BY CUBE
	(
	ShipMethodID, YEAR(OrderDate)
	)
	ORDER BY ShipMethodID, YEAR(OrderDate);
GO

---------------Using ROLLUP with the GROUPING function-----------------------------------------
USE AdventureWorks2012
GO

SELECT ShipMethodID, YEAR(OrderDate) AS N'Year Ordered', COUNT(*) AS 'Number of Orders', GROUPING(ShipMethodID) AS 'Grouping Ship Method'
	FROM Sales.SalesOrderHeader
	GROUP BY ROLLUP
	(
	ShipMethodID, YEAR(OrderDate)
	)
	ORDER BY ShipMethodID, YEAR(OrderDate);
GO	

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
/* Lesson 8.5 Use Window Aggregate Functions - INLINE */--------------------------------------
----------------------------------------------------------------------------------------------
USE AdventureWorks2012;
GO

SELECT ShipMethodID, YEAR(OrderDate) AS N'Year Ordered', COUNT(*) AS 'Number of Orders'
	,SUM(COUNT(*)) OVER(PARTITION BY ShipMethodID) AS 'Total per ShipMethod'
	,AVG(COUNT(*)) OVER(PARTITION BY ShipMethodID) AS 'Average per ShipMethod'
	,MAX(COUNT(*)) OVER(PARTITION BY ShipMethodID) AS 'Maximum per ShipMethod'
	,SUM(COUNT(*)) OVER() AS 'Grand Total of Orders'
	FROM  Sales.SalesOrderHeader
	GROUP BY ShipMethodID, YEAR(OrderDate)
	ORDER BY ShipMethodID, YEAR(OrderDate);
GO

USE AdventureWorks2012;
GO

SELECT CustomerID, SalesOrderID
	,Convert(Date,OrderDate) AS 'Order Date'
	, SubTotal
	,SUM(SubTotal) OVER(PARTITION BY CustomerID
		ORDER BY OrderDate, SalesOrderID
			ROWS BETWEEN UNBOUNDED PRECEDING
				AND CURRENT ROW) AS 'Running Total'
	FROM  Sales.SalesOrderHeader
	Where CustomerID IN ( 11000, 11001, 11002)
GO
	