/* -----Lesson 9.7 Demo 3 - Use XML Data Type Methods ---- */

---- Using XML query() Method--------------------------------
declare @mProd xml
set @mProd = '<Root>
<ProductDescription ProductID="19" ProductName="Mountain-100">
<Features>
  <Warranty>2 year parts</Warranty>
  <ExtendedMaintenance>extended warranty includes 5 years parts</ExtendedMaintenance>
  <Labor>Gold maintenance agreement includes labor</Labor>
</Features>
</ProductDescription>
</Root>'
SELECT @mProd.query('/Root/ProductDescription/Features')
GO


------Using XML value() Method------------------------------------
DECLARE @mProd xml
DECLARE @ProdID int
SET @mProd = '<Root>
<ProductDescription ProductID="19" ProductName="Mountain-100">
<Features>
  <Warranty>2 year parts</Warranty>
  <ExtendedMaintenance>extended warranty includes 5 years parts</ExtendedMaintenance>
  <Labor>Gold maintenance agreement includes labor</Labor>
</Features>
</ProductDescription>
</Root>'
SET @ProdID =  @mProd.value('(/Root/ProductDescription/@ProductID)[1]', 'int' )
SELECT @ProdID


--Using the value() and exist() methods to retrieve values from an xml type column ---
--Returning the products from Production.ProductModel with a CatalogDescription ------
Use AdventureWorks2012;
GO

SELECT CatalogDescription.value('
     declare namespace PD="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ProductModelDescription";
           (/PD:ProductDescription/@ProductModelID)[1] ', 'int') as ProductsWithCatalogDescription
FROM  Production.ProductModel
WHERE CatalogDescription.exist('
     declare namespace PD="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ProductModelDescription";
     declare namespace wm="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ProductModelWarrAndMain";
     /PD:ProductDescription/PD:Features/wm:Warranty ') = 1 --product description is not empty--
GO

--Using the value() method to retrieve a value from an xml type column-------------------
--Returning the products from Production.ProductModel with a CatalogDescription ---------
Use AdventureWorks2012;
GO

SELECT CatalogDescription.value('           
    declare namespace PD="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/ProductModelDescription";           
       (/PD:ProductDescription/@ProductModelID)[1]', 'int') AS ProductsWithCatalogDescription           
FROM Production.ProductModel           
WHERE CatalogDescription IS NOT NULL           
ORDER BY ProductsWithCatalogDescription desc    


